# TODOs list

## Vasileios's list

* The sparsity function for the `IGA_Context` class does not work properly when multiple patches are inserted.

* Perform more validation tests for the mixed (u/p) formulation of the IGA solid mechanics solver.

* Mind to enhance/change the way that the input reads BC-type for different types of solvers (biomech/biochem).

* Clean or/and reduce the code by doing the following things:
    1. Remove the intermediate_solution systems in the solid mechanics (FEM/IGA) solvers; application-wise it is obsolete.
    2. Remove from the wound-healing solver the wound-stitching case; this is no longer working properly.
    3. Create a branch version of [FEB3](https://bitbucket.org/vasvav/feb3-finite-element-bioengineering-in-3d/wiki/Home "Phoebe") and remove from the master branch the membrane elements; this will significantly reduce computations.

* In the tumour angiogenesis solver, should I just split the auxiliary solution into more systems; will this improve computational efficiency?

* Replace the (node & element) IDs in all containers for class `DomainData_SolidCoupledWithVascularNetwork` into pointers to `libMesh::Node` or `libMesh::Elem` respectively.
    - For now you can skip doing this task for: `NodalForceInfo`, `RegionInfo` and `DomainData` since the 3D mesh is not expected to change in the current modelling framework.
    - Likewise for classes: `VascularInfo` and `DomainData_VascularNetwork` because the 1D mesh is in serial and local mode.

* I need to add sub-iterations in the implicit scheme of the reaction-diffusion solver.

## Peter's list

* Merge the multiscale solid mechanics solvers into the master branch.
