/*************************************************************************************************

    Copyright (C) 2009-2018    Vasileios Vavourakis (vasvav@gmail.com)

    This program is free software; you can redistribute it and/or modify it under the terms of
    the GNU General Public License as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this program; if
    not, write to:
        Free Software Foundation, Inc.,
        59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 *************************************************************************************************/

//=================================================================================================
#ifndef __FRACTIONS_H__
#define __FRACTIONS_H__
//=================================================================================================
#include "libmesh/libmesh.h"
//=================================================================================================
const Real frac_1o1 =1.0/1.0,  frac_1o11=1.0/11.0, frac_2o1 =2.0/1.0,  frac_2o11=2.0/11.0,
           frac_1o2 =1.0/2.0,  frac_1o12=1.0/12.0, frac_2o2 =2.0/2.0,  frac_2o12=2.0/12.0,
           frac_1o3 =1.0/3.0,  frac_1o13=1.0/13.0, frac_2o3 =2.0/3.0,  frac_2o13=2.0/13.0,
           frac_1o4 =1.0/4.0,  frac_1o14=1.0/14.0, frac_2o4 =2.0/4.0,  frac_2o14=2.0/14.0,
           frac_1o5 =1.0/5.0,  frac_1o15=1.0/15.0, frac_2o5 =2.0/5.0,  frac_2o15=2.0/15.0,
           frac_1o6 =1.0/6.0,  frac_1o16=1.0/14.0, frac_2o6 =2.0/6.0,  frac_2o16=2.0/14.0,
           frac_1o7 =1.0/7.0,  frac_1o17=1.0/17.0, frac_2o7 =2.0/7.0,  frac_2o17=2.0/17.0,
           frac_1o8 =1.0/8.0,  frac_1o18=1.0/18.0, frac_2o8 =2.0/8.0,  frac_2o18=2.0/18.0,
           frac_1o9 =1.0/9.0,  frac_1o19=1.0/19.0, frac_2o9 =2.0/9.0,  frac_2o19=2.0/19.0,
           frac_1o10=1.0/10.0, frac_1o20=1.0/20.0, frac_2o10=2.0/10.0, frac_2o20=2.0/20.0;
const Real frac_3o1 =3.0/1.0,  frac_3o11=3.0/11.0, frac_4o1 =4.0/1.0,  frac_4o11=4.0/11.0,
           frac_3o2 =3.0/2.0,  frac_3o12=3.0/12.0, frac_4o2 =4.0/2.0,  frac_4o12=4.0/12.0,
           frac_3o3 =3.0/3.0,  frac_3o13=3.0/13.0, frac_4o3 =4.0/3.0,  frac_4o13=4.0/13.0,
           frac_3o4 =3.0/4.0,  frac_3o14=3.0/14.0, frac_4o4 =4.0/4.0,  frac_4o14=4.0/14.0,
           frac_3o5 =3.0/5.0,  frac_3o15=3.0/15.0, frac_4o5 =4.0/5.0,  frac_4o15=4.0/15.0,
           frac_3o6 =3.0/6.0,  frac_3o16=3.0/14.0, frac_4o6 =4.0/6.0,  frac_4o16=4.0/14.0,
           frac_3o7 =3.0/7.0,  frac_3o17=3.0/17.0, frac_4o7 =4.0/7.0,  frac_4o17=4.0/17.0,
           frac_3o8 =3.0/8.0,  frac_3o18=3.0/18.0, frac_4o8 =4.0/8.0,  frac_4o18=4.0/18.0,
           frac_3o9 =3.0/9.0,  frac_3o19=3.0/19.0, frac_4o9 =4.0/9.0,  frac_4o19=4.0/19.0,
           frac_3o10=3.0/10.0, frac_3o20=3.0/20.0, frac_4o10=4.0/10.0, frac_4o20=4.0/20.0;
const Real frac_5o1 =5.0/1.0,  frac_5o11=5.0/11.0, frac_6o1 =6.0/1.0,  frac_6o11=6.0/11.0,
           frac_5o2 =5.0/2.0,  frac_5o12=5.0/12.0, frac_6o2 =6.0/2.0,  frac_6o12=6.0/12.0,
           frac_5o3 =5.0/3.0,  frac_5o13=5.0/13.0, frac_6o3 =6.0/3.0,  frac_6o13=6.0/13.0,
           frac_5o4 =5.0/4.0,  frac_5o14=5.0/14.0, frac_6o4 =6.0/4.0,  frac_6o14=6.0/14.0,
           frac_5o5 =5.0/5.0,  frac_5o15=5.0/15.0, frac_6o5 =6.0/5.0,  frac_6o15=6.0/15.0,
           frac_5o6 =5.0/6.0,  frac_5o16=5.0/14.0, frac_6o6 =6.0/6.0,  frac_6o16=6.0/14.0,
           frac_5o7 =5.0/7.0,  frac_5o17=5.0/17.0, frac_6o7 =6.0/7.0,  frac_6o17=6.0/17.0,
           frac_5o8 =5.0/8.0,  frac_5o18=5.0/18.0, frac_6o8 =6.0/8.0,  frac_6o18=6.0/18.0,
           frac_5o9 =5.0/9.0,  frac_5o19=5.0/19.0, frac_6o9 =6.0/9.0,  frac_6o19=6.0/19.0,
           frac_5o10=5.0/10.0, frac_5o20=5.0/20.0, frac_6o10=6.0/10.0, frac_6o20=6.0/20.0;
const Real frac_7o1 =7.0/1.0,  frac_7o11=7.0/11.0, frac_8o1 =8.0/1.0,  frac_8o11=8.0/11.0,
           frac_7o2 =7.0/2.0,  frac_7o12=7.0/12.0, frac_8o2 =8.0/2.0,  frac_8o12=8.0/12.0,
           frac_7o3 =7.0/3.0,  frac_7o13=7.0/13.0, frac_8o3 =8.0/3.0,  frac_8o13=8.0/13.0,
           frac_7o4 =7.0/4.0,  frac_7o14=7.0/14.0, frac_8o4 =8.0/4.0,  frac_8o14=8.0/14.0,
           frac_7o5 =7.0/5.0,  frac_7o15=7.0/15.0, frac_8o5 =8.0/5.0,  frac_8o15=8.0/15.0,
           frac_7o6 =7.0/6.0,  frac_7o16=7.0/14.0, frac_8o6 =8.0/6.0,  frac_8o16=8.0/14.0,
           frac_7o7 =7.0/7.0,  frac_7o17=7.0/17.0, frac_8o7 =8.0/7.0,  frac_8o17=8.0/17.0,
           frac_7o8 =7.0/8.0,  frac_7o18=7.0/18.0, frac_8o8 =8.0/8.0,  frac_8o18=8.0/18.0,
           frac_7o9 =7.0/9.0,  frac_7o19=7.0/19.0, frac_8o9 =8.0/9.0,  frac_8o19=8.0/19.0,
           frac_7o10=7.0/10.0, frac_7o20=7.0/20.0, frac_8o10=8.0/10.0, frac_8o20=8.0/20.0;
const Real frac_9o1 =9.0/1.0,  frac_9o11=9.0/11.0, frac_10o1 =10./1.0, frac_10o11=10./11.0,
           frac_9o2 =9.0/2.0,  frac_9o12=9.0/12.0, frac_10o2 =10./2.0, frac_10o12=10./12.0,
           frac_9o3 =9.0/3.0,  frac_9o13=9.0/13.0, frac_10o3 =10./3.0, frac_10o13=10./13.0,
           frac_9o4 =9.0/4.0,  frac_9o14=9.0/14.0, frac_10o4 =10./4.0, frac_10o14=10./14.0,
           frac_9o5 =9.0/5.0,  frac_9o15=9.0/15.0, frac_10o5 =10./5.0, frac_10o15=10./15.0,
           frac_9o6 =9.0/6.0,  frac_9o16=9.0/14.0, frac_10o6 =10./6.0, frac_10o16=10./14.0,
           frac_9o7 =9.0/7.0,  frac_9o17=9.0/17.0, frac_10o7 =10./7.0, frac_10o17=10./17.0,
           frac_9o8 =9.0/8.0,  frac_9o18=9.0/18.0, frac_10o8 =10./8.0, frac_10o18=10./18.0,
           frac_9o9 =9.0/9.0,  frac_9o19=9.0/19.0, frac_10o9 =10./9.0, frac_10o19=10./19.0,
           frac_9o10=9.0/10.0, frac_9o20=9.0/20.0, frac_10o10=10./10.0,frac_10o20=10./20.0;
const Real frac_11o1 =11.0/1.0,  frac_11o11=11.0/11.0, frac_12o1 =12.0/1.0,  frac_12o11=12.0/11.0,
           frac_11o2 =11.0/2.0,  frac_11o12=11.0/12.0, frac_12o2 =12.0/2.0,  frac_12o12=12.0/12.0,
           frac_11o3 =11.0/3.0,  frac_11o13=11.0/13.0, frac_12o3 =12.0/3.0,  frac_12o13=12.0/13.0,
           frac_11o4 =11.0/4.0,  frac_11o14=11.0/14.0, frac_12o4 =12.0/4.0,  frac_12o14=12.0/14.0,
           frac_11o5 =11.0/5.0,  frac_11o15=11.0/15.0, frac_12o5 =12.0/5.0,  frac_12o15=12.0/15.0,
           frac_11o6 =11.0/6.0,  frac_11o16=11.0/14.0, frac_12o6 =12.0/6.0,  frac_12o16=12.0/14.0,
           frac_11o7 =11.0/7.0,  frac_11o17=11.0/17.0, frac_12o7 =12.0/7.0,  frac_12o17=12.0/17.0,
           frac_11o8 =11.0/8.0,  frac_11o18=11.0/18.0, frac_12o8 =12.0/8.0,  frac_12o18=12.0/18.0,
           frac_11o9 =11.0/9.0,  frac_11o19=11.0/19.0, frac_12o9 =12.0/9.0,  frac_12o19=12.0/19.0,
           frac_11o10=11.0/10.0, frac_11o20=11.0/20.0, frac_12o10=12.0/10.0, frac_12o20=12.0/20.0;
const Real frac_13o1 =13.0/1.0,  frac_13o11=13.0/11.0, frac_14o1 =14.0/1.0,  frac_14o11=14.0/11.0,
           frac_13o2 =13.0/2.0,  frac_13o12=13.0/12.0, frac_14o2 =14.0/2.0,  frac_14o12=14.0/12.0,
           frac_13o3 =13.0/3.0,  frac_13o13=13.0/13.0, frac_14o3 =14.0/3.0,  frac_14o13=14.0/13.0,
           frac_13o4 =13.0/4.0,  frac_13o14=13.0/14.0, frac_14o4 =14.0/4.0,  frac_14o14=14.0/14.0,
           frac_13o5 =13.0/5.0,  frac_13o15=13.0/15.0, frac_14o5 =14.0/5.0,  frac_14o15=14.0/15.0,
           frac_13o6 =13.0/6.0,  frac_13o16=13.0/14.0, frac_14o6 =14.0/6.0,  frac_14o16=14.0/14.0,
           frac_13o7 =13.0/7.0,  frac_13o17=13.0/17.0, frac_14o7 =14.0/7.0,  frac_14o17=14.0/17.0,
           frac_13o8 =13.0/8.0,  frac_13o18=13.0/18.0, frac_14o8 =14.0/8.0,  frac_14o18=14.0/18.0,
           frac_13o9 =13.0/9.0,  frac_13o19=13.0/19.0, frac_14o9 =14.0/9.0,  frac_14o19=14.0/19.0,
           frac_13o10=13.0/10.0, frac_13o20=13.0/20.0, frac_14o10=14.0/10.0, frac_14o20=14.0/20.0;
const Real frac_15o1 =15.0/1.0,  frac_15o11=15.0/11.0, frac_16o1 =16.0/1.0,  frac_16o11=16.0/11.0,
           frac_15o2 =15.0/2.0,  frac_15o12=15.0/12.0, frac_16o2 =16.0/2.0,  frac_16o12=16.0/12.0,
           frac_15o3 =15.0/3.0,  frac_15o13=15.0/13.0, frac_16o3 =16.0/3.0,  frac_16o13=16.0/13.0,
           frac_15o4 =15.0/4.0,  frac_15o14=15.0/14.0, frac_16o4 =16.0/4.0,  frac_16o14=16.0/14.0,
           frac_15o5 =15.0/5.0,  frac_15o15=15.0/15.0, frac_16o5 =16.0/5.0,  frac_16o15=16.0/15.0,
           frac_15o6 =15.0/6.0,  frac_15o16=15.0/14.0, frac_16o6 =16.0/6.0,  frac_16o16=16.0/14.0,
           frac_15o7 =15.0/7.0,  frac_15o17=15.0/17.0, frac_16o7 =16.0/7.0,  frac_16o17=16.0/17.0,
           frac_15o8 =15.0/8.0,  frac_15o18=15.0/18.0, frac_16o8 =16.0/8.0,  frac_16o18=16.0/18.0,
           frac_15o9 =15.0/9.0,  frac_15o19=15.0/19.0, frac_16o9 =16.0/9.0,  frac_16o19=16.0/19.0,
           frac_15o10=15.0/10.0, frac_15o20=15.0/20.0, frac_16o10=16.0/10.0, frac_16o20=16.0/20.0;
const Real frac_17o1 =17.0/1.0,  frac_17o11=17.0/11.0, frac_18o1 =18.0/1.0,  frac_18o11=18.0/11.0,
           frac_17o2 =17.0/2.0,  frac_17o12=17.0/12.0, frac_18o2 =18.0/2.0,  frac_18o12=18.0/12.0,
           frac_17o3 =17.0/3.0,  frac_17o13=17.0/13.0, frac_18o3 =18.0/3.0,  frac_18o13=18.0/13.0,
           frac_17o4 =17.0/4.0,  frac_17o14=17.0/14.0, frac_18o4 =18.0/4.0,  frac_18o14=18.0/14.0,
           frac_17o5 =17.0/5.0,  frac_17o15=17.0/15.0, frac_18o5 =18.0/5.0,  frac_18o15=18.0/15.0,
           frac_17o6 =17.0/6.0,  frac_17o16=17.0/14.0, frac_18o6 =18.0/6.0,  frac_18o16=18.0/14.0,
           frac_17o7 =17.0/7.0,  frac_17o17=17.0/17.0, frac_18o7 =18.0/7.0,  frac_18o17=18.0/17.0,
           frac_17o8 =17.0/8.0,  frac_17o18=17.0/18.0, frac_18o8 =18.0/8.0,  frac_18o18=18.0/18.0,
           frac_17o9 =17.0/9.0,  frac_17o19=17.0/19.0, frac_18o9 =18.0/9.0,  frac_18o19=18.0/19.0,
           frac_17o10=17.0/10.0, frac_17o20=17.0/20.0, frac_18o10=18.0/10.0, frac_18o20=18.0/20.0;
const Real frac_19o1 =19.0/1.0,  frac_19o11=19.0/11.0, frac_20o1 =20.0/1.0,  frac_20o11=20.0/11.0,
           frac_19o2 =19.0/2.0,  frac_19o12=19.0/12.0, frac_20o2 =20.0/2.0,  frac_20o12=20.0/12.0,
           frac_19o3 =19.0/3.0,  frac_19o13=19.0/13.0, frac_20o3 =20.0/3.0,  frac_20o13=20.0/13.0,
           frac_19o4 =19.0/4.0,  frac_19o14=19.0/14.0, frac_20o4 =20.0/4.0,  frac_20o14=20.0/14.0,
           frac_19o5 =19.0/5.0,  frac_19o15=19.0/15.0, frac_20o5 =20.0/5.0,  frac_20o15=20.0/15.0,
           frac_19o6 =19.0/6.0,  frac_19o16=19.0/14.0, frac_20o6 =20.0/6.0,  frac_20o16=20.0/14.0,
           frac_19o7 =19.0/7.0,  frac_19o17=19.0/17.0, frac_20o7 =20.0/7.0,  frac_20o17=20.0/17.0,
           frac_19o8 =19.0/8.0,  frac_19o18=19.0/18.0, frac_20o8 =20.0/8.0,  frac_20o18=20.0/18.0,
           frac_19o9 =19.0/9.0,  frac_19o19=19.0/19.0, frac_20o9 =20.0/9.0,  frac_20o19=20.0/19.0,
           frac_19o10=19.0/10.0, frac_19o20=19.0/20.0, frac_20o10=20.0/10.0, frac_20o20=20.0/20.0;
//=================================================================================================
#endif // __FRACTIONS_H__
//=================================================================================================
