/*************************************************************************************************

    Copyright (C) 2009-2018    Vasileios Vavourakis (vasvav@gmail.com)

    This program is free software; you can redistribute it and/or modify it under the terms of
    the GNU General Public License as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this program; if
    not, write to:
        Free Software Foundation, Inc.,
        59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 *************************************************************************************************/

//=================================================================================================
#ifndef __UTILS__MATERIAL_INFO_H__
#define __UTILS__MATERIAL_INFO_H__
//=================================================================================================
class MaterialInfo {
public:
    explicit MaterialInfo (int nbmech =0, int nbchem =0);
    ~MaterialInfo () {}
    //
    inline
    std::string&       set_title () { return this->_title; }
    inline
    const std::string& get_title () const { return this->_title; }
    inline
    std::vector<Real>&       set_biomech_param () { return this->_biomech; }
    inline
    const std::vector<Real>& get_biomech_param () const { return this->_biomech; }
    inline
    Real& set_biomech_param (unsigned int i) { return this->_biomech.at(i); }
    inline
    Real  get_biomech_param (unsigned int i) const { return this->_biomech[i]; }
    inline
    std::vector<Real>&       set_biochem_param () { return this->_biochem; }
    inline
    const std::vector<Real>& get_biochem_param () const { return this->_biochem; }
    inline
    Real& set_biochem_param (unsigned int i) { return this->_biochem.at(i); }
    inline
    Real  get_biochem_param (unsigned int i) const { return this->_biochem[i]; }
private:
    std::string _title;
    std::vector<Real> _biomech;
    std::vector<Real> _biochem;
};
//=================================================================================================
//
//
//
//=================================================================================================
inline
MaterialInfo::MaterialInfo (int nbmech, int nbchem) {
    // default title name for the material
    this->_title = "a_material";
    //
    if ( nbmech ) this->_biomech.assign(nbmech, 0.0);
    if ( nbchem ) this->_biochem.assign(nbchem, 0.0);
}
//=================================================================================================
#endif // __UTILS__MATERIAL_INFO_H__
//=================================================================================================
