/*************************************************************************************************

    Copyright (C) 2009-2018    Vasileios Vavourakis (vasvav@gmail.com)

    This program is free software; you can redistribute it and/or modify it under the terms of
    the GNU General Public License as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this program; if
    not, write to:
        Free Software Foundation, Inc.,
        59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 *************************************************************************************************/

//=================================================================================================
#include "feb3/utils.h"
#include "feb3/domain_data.h"
#include "libmesh/getpot.h"
#include "libmesh/libmesh_logging.h"
#include "libmesh/mesh.h"
#include "feb3/utils.h"
//=================================================================================================
// external variables
extern
OFStream flog, ferr;
extern
GlobalTolerance tol;
//=================================================================================================
void eigenproblem_test () {
    Dyadic3D A;
    A.comp = 40, -20,   1e-12,
            -20,  40, -20,
              0, -20,  40;
    if ( true ) {
        std::cout << "                                      \n"
                  << A.comp << std::endl;
    }
    if ( true ) {
        std::cout << std::endl;
        //
        std::vector<Real> l;
        std::vector<Vector3D> v;
        eigen_solve(A, l, v);
        for (int i=0; i<3; i++) {
            std::cout << l[i] << ' ' << magnitude(v[i]) << ' ' << v[i].comp << std::endl;
        }
        //
        std::cout << std::endl;
    }
    if ( true ) {
        std::cout << std::endl;
        //
        Real l;
        Vector3D v;
        l = min_eigen(A, v);
        std::cout << l << ' ' << magnitude(v) << ' ' << v.comp << std::endl;
        v = min_eigen(A);
        std::cout << magnitude(v) << ' ' << unit(v).comp << std::endl;
        l = max_eigen(A, v);
        std::cout << l << ' ' << magnitude(v) << ' ' << v.comp << std::endl;
        v = max_eigen(A);
        std::cout << magnitude(v) << ' ' << unit(v).comp << std::endl;
        //
        Point p = vec(unit(v));
        Dyadic3D a = tensor(p, p);
        std::cout << a.comp << std::endl;
        //
        std::cout << std::endl;
    }
}
//=================================================================================================
