/*************************************************************************************************

    Copyright (C) 2009-2019    Vasileios Vavourakis (vasvav@gmail.com)

    This program is free software; you can redistribute it and/or modify it under the terms of
    the GNU General Public License as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
    without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
    the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this program; if
    not, write to:
        Free Software Foundation, Inc.,
        59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

 *************************************************************************************************/

//=================================================================================================
#include "feb3/utils.h"
#include "libmesh/getpot.h"
#include "libmesh/libmesh_logging.h"
//=================================================================================================
// external variables
extern
OFStream flog, ferr;
extern
GlobalTolerance tol;
//=================================================================================================
// external routines
extern
void test_generate_rve ();
extern
void generate_vascular_network ();
extern
void translate_vascular_network ();
extern
void prepare_vascular_network ();
//=================================================================================================
void run_a_utility (const char* arg) {
    std::cout << "\n *** Running a utility with FEB3...\r" << std::flush;

    flog.open("run_a_utility.log", true);
    ferr.open("run_a_utility.err", true);
    if ( ! arg ) ERROR_("input argument is not properly initialised");
    else if ( 0 == strcmp(arg, "test_generate_rve") ) test_generate_rve();
    else if ( 0 == strcmp(arg, "generate_vascular_network") )  generate_vascular_network();
    else if ( 0 == strcmp(arg, "translate_vascular_network") ) translate_vascular_network();
    else if ( 0 == strcmp(arg, "prepare_vascular_network") )   prepare_vascular_network();
    else ERROR_("exception caught for the kind of utility to run");

    std::cout << " *** Running a utility with FEB3... [  OK  ]\n" << std::endl;
}
//=================================================================================================
